#include "funkce.h"
#include "avr\eeprom.h"
#include "avr\interrupt.h"

extern unsigned char TLAC;

extern unsigned char CITLIVOST;
extern unsigned char CITLIVOST_AUTO;
extern unsigned char CIVKA;
extern unsigned char PODSVIT;
extern unsigned char ALGORIT;

extern unsigned char EEPROM EE_CIVKA;
extern unsigned char EEPROM EE_PODSVIT;
extern unsigned char EEPROM EE_ALGORIT;

extern struct KOEF EEPROM EE_koef;

extern float a,b;

extern unsigned int data_prum[103];

extern unsigned int mil,sec;




//---------------------------------------------------
void demx(char kanal)
{
kanal<<=3;
PORTB=(PORTB&0b11000111)|((~kanal)&(~0b11000111));

}
//---------------------------------------------------
void volume(char *x,char max)
{
signed char x_out=*x;

if(TLAC0&&TLAC){x_out++;TLAC=false;}
if(TLAC2&&TLAC){x_out--;TLAC=false;}

if(x_out<0)(x_out)=0;
if(x_out>max)x_out=max;

*x=x_out;
}
//---------------------------------------------------
int volume2(signed int x_out,int max)
{
static unsigned char old=0;
static unsigned char old2=0;
signed int x_old;
static unsigned int mil_old;
static unsigned char rychlost=0;
unsigned char rychlost_old;
//signed int x_out=*x;


#define POMALYCH_ZNAKU 3


if(old2<POMALYCH_ZNAKU)if(!TLAC)return x_out;


old2++;

x_old=x_out;

rychlost_old=rychlost;

if(old<10)
 {
  if(TLAC0){x_out++;}
  if(TLAC2){x_out--;}
  rychlost=0;
 }
else if(old>20)
 {
  if(TLAC0){x_out+=100;}
  if(TLAC2){x_out-=100;}
  rychlost=3;
 }
else
 {  
  if(TLAC0){x_out+=10;}
  if(TLAC2){x_out-=10;}
  rychlost=1;
 }

if(rychlost!=rychlost_old)old2=0;

if(x_old!=x_out)	//jestlize bylo pricteno/odecteno
{
 TLAC=false;
 
 if(old2>=POMALYCH_ZNAKU)old++;
 else old=(old/10)*10;

 cli();
 mil_old=mil;
 sei();
}
else 				//jestlize nebylo nic stisknuto
 {
 old2=0;
 }

cli();
if(mil-mil_old>1400)
 {
 old=0;
 mil_old=mil;
 }
sei();

if(x_out<0)x_out=0;
if(x_out>max)x_out=max;

return x_out;
}
//---------------------------------------------------
void load_EEPROM(void)
{
//CITLIVOST=eeprom_read_byte(0);
CIVKA=eeprom_read_byte(&EE_CIVKA);
PODSVIT=eeprom_read_byte(&EE_PODSVIT);
ALGORIT=eeprom_read_byte(&EE_ALGORIT);

if(CIVKA>4)CIVKA=0;
if(PODSVIT>2)PODSVIT=0;
if(ALGORIT>1)ALGORIT=1;


read_kalib(CITLIVOST-1,CIVKA,ALGORIT);
}
//---------------------------------------------------
int signal(int *pole)
{
unsigned char i;
int max=0;
int min=2000;
long avg=0;
int a;
unsigned char b;
long low,high;


for(i=0;i<MAX_DAT;i++)
 pole[i]=pole[i]/25;	//v poli je soucet 25 mereni z nich se vypocita pro kazdy prvek prumerna hodnota




for(i=0;i<MAX_DAT;i++)
{
if(min>pole[i])min=pole[i];
if(max<pole[i])max=pole[i];
avg+=pole[i];
}

avg/=MAX_DAT;


if(ALGORIT)	//jestlize je algoritmus odsumeni 
{//a

//ref = 2.56V -> 1dgt=2.502mV(2.5mV)

/*


	|                     /max
U[V]|                    /
	|					*  				
	|   ***        *** * ** ****     ---high=prumer ze vzorku mezi "max" a "a_max"     
	|  *   *      *   *    *    *    ---a_max=max-250mV(-110)
    |  *    *     *             *
	| *     *    *              *    ---a_min=min+150mV(+60)
	|*       ** *                ****---low=prumer ze vzorku mezi "min" a "a_min"
	|__________*____________________________________
				\				    /|\	  t[vzorky]
				 \min				 |
									MAX_DAT

Vysledek algoritmu je delta (high-low)

*/


a=max-110;	//max-250mV
b=0;
high=0;
for(i=0;i<MAX_DAT;i++)
{
if(pole[i]>a)
 {
 high+=pole[i];
 b++;
 } 
}

high/=b;

a=min+30;	//60 //min+150mV
b=0;
low=0;
for(i=0;i<MAX_DAT;i++)
{
if(pole[i]<a)
 {
 low+=pole[i];
 b++;
 } 
}

low/=b;



if(max==1023)return 9999;
return (int)(high-low);
}//a
else	//jestlize je jednoduchy algoritmus
{
 return (unsigned int)avg;
}

}
//---------------------------------------------------
/*
find_min()

find_max()
find_avg();


int min;
int max; 
int avg;

//najdou se krajni hodnoty
min=find_min(&data);
max=find_max(&data);
avg=find_avg(&data);



*/
//---------------------------------------------------
inline void save_kalib(char citlivost,char civka,char algorit)
{


eeprom_write_float(&EE_koef.a[civka][citlivost][algorit],a);
eeprom_write_float(&EE_koef.b[civka][citlivost][algorit],b);

/*
unsigned int i=ADR_KALIB+8*6*2*civka+citlivost*8*2+algorit*8;

for(civka=0;civka<4;civka++)
{
eeprom_write_byte (i,*(a++));
eeprom_write_byte (4+(i++),*(b++));
}
*/

}
//---------------------------------------------------
inline void read_kalib(char citlivost,char civka,char algorit)
{


a=eeprom_read_float(&EE_koef.a[civka][citlivost][algorit]);
b=eeprom_read_float(&EE_koef.b[civka][citlivost][algorit]);

/*
for(civka=0;civka<4;civka++)
{
*(a++)=eeprom_read_byte (i);
*(b++)=eeprom_read_byte ((i++)+4);
}
*/


}
//---------------------------------------------------
