#include "avr\io.h"
#include "avr\pgmspace.h"
#include "lcd.h"
#include "delay_moje.h"
#include "define.h"
#include "radiomajak.h"
//---------------------------------------------------
volatile void delay_LCD(void)
{
//Dle katalogu 40us

volatile unsigned char i;

#ifndef SIMULACE
for(i=0;i<((4*F_CPU)/1000000);i++);
#endif


}

//---------------------------------------------------
unsigned char zrcadli(unsigned char in)
{
volatile unsigned char out=0,i;
for(i=0;i<4;i++)
{
out>>=1;
out|=((in)<<(i))&0b10001000;
}

return out;

}
//---------------------------------------------------

void LCD_init(void)
{

DDR_E|=1<<BIT_E;
DDR_RS|=1<<BIT_RS;
DDR_LCD_LED|=1<<BIT_LCD_LED;
LCD_DDR|=LCD_INIT_PORT;	//0b00001111


LCD_w_instrukce(0b00110011,1);	//33
LCD_w_instrukce(0b00110010,1);	//32
LCD_w_instrukce(0b00101000,1);	//28
LCD_w_instrukce(0b00001100,1);	//0c
LCD_w_instrukce(0b00000010,1);
LCD_w_instrukce(0b00000001,1);


}
//-----------------------------------------------------

void LCD_w_char(unsigned char bajt)
{
#ifdef ZRCADLI
bajt=zrcadli(bajt);
#endif

DATA;
HODINY0;
LCD_PORT=(LCD_PORT&0xf0)|((bajt>>4)&0x0f);
delay_LCD();
HODINY1;
delay_LCD();
HODINY0;
LCD_PORT=(LCD_PORT&0xf0)|((bajt)&0x0f);
delay_LCD();
HODINY1;
delay_LCD();
HODINY0;

}
//---------------------------------------------------
void LCD_w_instrukce(unsigned char bajt,char delay)
{
#ifdef ZRCADLI
bajt=zrcadli(bajt);
#endif

INSTUKCE;
HODINY0;
LCD_PORT=(LCD_PORT&0xf0)|((bajt>>4)&0x0f);
delay_LCD();
if(delay) delay_1m(2);
HODINY1;
delay_LCD();
HODINY0;
LCD_PORT=(LCD_PORT&0xf0)|((bajt)&0x0f);
delay_LCD();
if(delay) delay_1m(2);
HODINY1;
delay_LCD();
HODINY0;
delay_LCD();
if(delay) delay_1m(2);




}


//---------------------------------------------------
void LCD_w_string(unsigned char *retezec)
{
volatile unsigned char i;

for(i=0;retezec[i]!=0;i++)
LCD_w_char(retezec[i]);
}

//---------------------------------------------------
void LCD_w_string_pgm(unsigned int retezec)
{
unsigned char byte;


while(byte=pgm_read_byte(retezec++))
{
LCD_w_char(byte);
}



}
//---------------------------------------------------
void LCD_w_menu_pgm(unsigned int retezec,unsigned char pocet_znaku,unsigned char menu)
{
unsigned char byte;
menu*=pocet_znaku;


while(byte=pgm_read_byte(menu+(retezec++)))
{
LCD_w_char(byte);
}



}
//---------------------------------------------------
unsigned char LCD_w_string_bezici_pgm(unsigned int retezec,char x)
 {
  unsigned char byte;
  unsigned char i;

  pozice_LCD(0); 

  #define ZNAKU 16

  for(i=x;i<x+ZNAKU;i++)
   {
    if(!(byte=pgm_read_byte(retezec+i)))return 0xff;
    LCD_w_char(byte);

   }

 }

//---------------------------------------------------
unsigned char LCD_w_string_bezici(unsigned char *retezec,char x)
 {
  
  unsigned char i;

  pozice_LCD(0); 

  #define ZNAKU 16

  if(!(retezec[x+ZNAKU-1]))return 0;

  for(i=x;i<x+ZNAKU;i++)
   {
    LCD_w_char(retezec[i]);
   }

   return -1;

 }
//---------------------------------------------------

void LCD_w_int2str(int x,char znaku,char tecka)
{
// znaku - celkovy pocet znaku jestlize je kladny tak se pred znaky zobrazi volna mista jestli zaporny dosadi se nuly, pokud je rovna 0 pak se cislo vytvori podle poctu desetinych mist
// tecka - vytvori se desetina tecka na pozici z leva 

#define TEXT_LENGTH 13

char cifer;
char znamenko=0;
char i,j;
char text[TEXT_LENGTH];


if(x<0)
 {
 znamenko=1;
 x=-x;
 }


i=TEXT_LENGTH-1;

for(cifer=0;(x>0) || (cifer<=tecka);cifer++)	//zjisti kolik cifer ma x a vypocita jednotlive cifry
 {
  if(tecka==cifer)
   {
   if(cifer)
    text[i--]='.';

   //if(!(x%10))
   }

  text[i--]=(x%10)+'0';
  x/=10;
  
 }

if(znaku<0)
{
znaku=-znaku;

for(;((TEXT_LENGTH-1)-i)<znaku-znamenko;i--)
 text[i]='0';

}

if(znamenko) text[i--]='-';

i++;

for(j=0;i<TEXT_LENGTH;i++)
 {
 text[j++]=text[i];
 }

for(;j<znaku;j++)
 text[j]=' ';

text[j]=0;



for(i=0;text[i]!=0;i++)
{
LCD_w_char(text[i]);
}

}
//---------------------------------------------------

void LCD_w_long2str(long x,char znaku,char tecka)
{
// znaku - celkovy pocet znaku jestlize je kladny tak se pred znaky zobrazi volna mista jestli zaporny dosadi se nuly, pokud je rovna 0 pak se cislo vytvori podle poctu desetinych mist
// tecka - vytvori se desetina tecka na pozici z leva 

#define TEXT_LENGTH 13

char cifer;
char znamenko=0;
char i,j;
char text[TEXT_LENGTH];


if(x<0)
 {
 znamenko=1;
 x=-x;
 }


i=TEXT_LENGTH-1;

for(cifer=0;(x>0) || (cifer<=tecka);cifer++)	//zjisti kolik cifer ma x a vypocita jednotlive cifry
 {
  if(tecka==cifer)
   {
   if(cifer)
    text[i--]='.';

   //if(!(x%10))
   }

  text[i--]=(x%10)+'0';
  x/=10;
  
 }

if(znaku<0)
{
znaku=-znaku;

for(;((TEXT_LENGTH-1)-i)<znaku-znamenko;i--)
 text[i]='0';

}

if(znamenko) text[i--]='-';

i++;

for(j=0;i<TEXT_LENGTH;i++)
 {
 text[j++]=text[i];
 }

for(;j<znaku;j++)
 text[j]=' ';

text[j]=0;



for(i=0;text[i]!=0;i++)
{
LCD_w_char(text[i]);
}

}
