#ifndef LCD_H
#define LCD_H
//----------------
//#include "avr\io.h"
//#include "avr\pgmspace.h"
//#include "math.h"
#include "radiomajak.h"


/*******************
INICIALIZACE
********************/


//Hodiny
#define DDR_E DDRC
#define PORT_E PORTC
#define BIT_E PB5

//Data/Instrukce
#define DDR_RS DDRD
#define PORT_RS PORTD
#define BIT_RS PB0

//Podsviceni
#define DDR_LCD_LED DDRB
#define PORT_LCD_LED PORTB
#define BIT_LCD_LED PB6

//Data
#define LCD_DDR DDRC
#define LCD_PORT PORTC
#define LCD_INIT_PORT 0b00001111


#ifndef SIMULACE

//Zrcadleni
#define ZRCADLI

#endif




/*******************
INICIALIZACE KONEC
********************/

/*
01- GND
02- +5V
03- Kontrast
04- RS (data/instrukce)
05- R/W (Cteni/zapis)
06- E (enable - hodiny)
07- DB0
08- DB1
09- DB2
10- DB3
11- DB4  \ 
12- DB5  -|
13- DB6  -|-Pripojeni 4bit komunikace DB4=DB0, atd...
14- DB7  /
15- LEDA +
16- LEDK -
*/


#define HODINY1 PORT_E|=(1<<BIT_E)
#define HODINY0 PORT_E&=~(1<<BIT_E)

#define INSTUKCE PORT_RS&=~(1<<BIT_RS)
#define DATA PORT_RS|=(1<<BIT_RS)

#define LCD_LED_ON PORT_LCD_LED|=(1<<BIT_LCD_LED)
#define LCD_LED_OFF PORT_LCD_LED&=~(1<<BIT_LCD_LED)





#define pozice_LCD(x) LCD_w_instrukce(0b10000000|x,0)

//#define pozice_LCD(x) w_instrukce(0b10000000|x,0)
#define pozice_LCD2(x) LCD_w_instrukce(0b11000000|x,0)

void LCD_init(void); 	//Inicializace LCD
void delay_LCD(void);	//Spozdeni 40us pro LCD
unsigned char zrcadli(unsigned char in);	//Funkce zrcadli pro spatne zapojene piny
void LCD_w_char(unsigned char bajt);			//
void LCD_w_instrukce(unsigned char bajt,char delay);
void LCD_w_string(unsigned char *retezec);
unsigned char LCD_w_string_bezici_pgm(unsigned int retezec,char x);
unsigned char LCD_w_string_bezici(unsigned char *retezec,char x);
void LCD_w_string_pgm(unsigned int retezec);
void LCD_w_menu_pgm(unsigned int retezec,unsigned char pocet_znaku,unsigned char menu);	//Vypise menu char[] a="Menu1 \0 Menu2 \0 Menu3 ";

void LCD_w_int2str(int x,char znaku,char tecka);
void LCD_w_long2str(long x,char znaku,char tecka);

//----------------
#endif LCD_H
