/*
2.2.3
- eeprom je organizovana pomoci struktury EE_koef
- vytvoren soubor civka1.eep ve ktere jsou ulozeny koeficienty pro civku 1
- opsany koeficienty "a" a "b" pro civku 1 do programu a kdykoli jdou ulozit do eeprom


2.2.2
- text "if(data_prum_poz>(MAX_DAT-2))" zmenen na "if(data_prum_poz>=MAX_DAT)"
- radek z funkce int signal(int *pole) zmenen na 30 ze 60 -> a=min+30;	//60 //min+150mV
- v algoritmu signal(int *pole) se do verze 2.2.1 pocitala low hodnota z prumeru hodnot 0+60 ted zmeneno na min+30
- Dodelana detekce nizkeho stavu baterie
- v adc vytvorena dalsi moznost pro odstraneni prvniho chybneho vzorku pri mereni napeti
- Nachystano cteni koeficientu z eeprom pomoci struktury



2.2.1
- Opravena chyba preskoceni ukladani citlivosti 	
- upraven program pro ladeni (#define LADENI)

2.2.0 	
- Dodelana moznost pri kalibraci preskocit na dalsi citlivost bez ukladani.
- Do prumeru kalibrace se nepocita prvni nestabilni hodnota (ale a dal stabiln)

2.1.6
- Plne fukcni finalni verze
*/

#include "avr\io.h" 		// definin soubor pro mikrokontrolr
#include "avr\interrupt.h" 	// peruen mikrokontrolru
#include "lcd.h"
#include "math.h"
#include "avr\eeprom.h"
#include "avr\pgmspace.h"
#include "funkce.h"
#include "radiomajak.h"
#include "delay_moje.h"

#define MIN_NAP 80 		//minimalni napeti ktere se da jeste merit
#define MAX_NAP 800 	//maximalni napeti ktere se da jeste merit

#define POCET_VZORKU_DEF 5	//pri kalibraci defaultni pocet vzorku pro prumerovani

char typ_mereni=0;

volatile unsigned int mil=0,sec=0;
unsigned int Vbat;
//unsigned int data[256];
//unsigned char data_poz=0;
unsigned int data_prum[MAX_DAT];
volatile unsigned char data_prum_poz=0;
//int nula;

unsigned char TLAC=false;
unsigned char tlac0=0,tlac1=0,tlac2=0;
unsigned char CITLIVOST=6;
unsigned char CITLIVOST_AUTO=6;
unsigned char CIVKA;
unsigned char PODSVIT;
unsigned char ALGORIT;

unsigned char EEPROM EE_CIVKA;
unsigned char EEPROM EE_PODSVIT;
unsigned char EEPROM EE_ALGORIT;

struct KOEF EEPROM EE_koef;

unsigned char reset_Vmer=0;

volatile float a,b;

unsigned int NULA;


unsigned char bezici_buf[150];



PROGMEM char menu[]="Mereni  \0Civka   \0Kalib.  \0Ubat    \0Podsvit \0Prumeruj\0Cancel";
PROGMEM char menu_podsvit[]="Vypnuto\0Zapnuto\0Auto    ";
PROGMEM char menu_algo[]=   "Prumer    \0Algoritmus";
//PROGMEM char menu_ano_ne[]=   "Ne    \0Ano   ";
PROGMEM char menu_ano_ne[]=   "Ne    \0Ano   ";
//							   Storno  Neuloz
PROGMEM char nic[]=    "                ";

/*
PROGMEM char video[]  ={"    .     <-0m  \0"
						"   (.)    <-0m  \0"
						"  ( . )   <-0m  \0"
						" (  .  )  <-0m  \0"
						"(  (.)  ) <-0m  \0"
						"  ( . )  )<-0m  \0"
						" (  X  )  <-zde \0"
						"(  (X)  ) <-8m  \0"
						"  ( X )  )<-8m  \0"

};
*/

//PROGMEM char menu_1[]= "Algoritmus:  ** ";
//PROGMEM char menu_2[]= "Vyber vys.civku:";
//PROGMEM char menu_3[]= "Napeti baterii: ";
//PROGMEM char menu_4[]= "Podsvetleni: ***";

//PROGMEM char menu_00[]="h=000.0m M......";
//PROGMEM char menu_01[]="U=              ";

//PROGMEM char menu_10[]="Kalibrovat?  ** ";


//PROGMEM char kal_01[]= "Nalezni napeti mezi 600-750 a zadej vzdalenost l od vysilace.Pak stiskni OK. ";
//PROGMEM char kal_02[]= "Nalezni napeti mezi 170-220 a zadej vzdalenost l od vysilace.Pak stiskni OK. ";

//PROGMEM char kal_03[]= "2.nalezni napeti";
//PROGMEM char kal_04[]= "mezi 170-220  OK";


//---------------------------------------------


// Timer/Counter2 Compare Match OCR2
ISR(TIMER2_COMP_vect)
{
//preruseni nastava co 426,6666666us

//1ms se cita po 853us (skut ms se musi vznasobit 1.171)

AD_start;	//zapnuti mereni 
volatile static unsigned char a=0;

if((a++)&1)
if(!((mil++)%1171))
 {
	sec++;
 }




}
//---------------------------------------------------

// Peruen pi peteen T/T0
ISR(TIMER0_OVF_vect)
{
//preruseni nastava co 10.922ms
static unsigned char opak=0;
static unsigned char x=0;
static unsigned char tlac_old=0;
static unsigned char tlac_on=true;

static char a=-1;
static char pin_old=0b1110;
static unsigned int mil_old;



if(TIFR & (1<<OCF2))return; //jestlize nastalo preruseni T2
if(TCNT2>(38-2))return;

//preruseni nastava co 10ms


if(opak==3)	//vzdy po 65ms se testuji tlacitka
{


/*
if((PIND&0b1110)!=0b1110)	//sestlize je stisknuto nejake tlac.
{
if((PIND&0b1110)==pin_old)	//jestlize je stisknuto stare tlac.
 {

 }
else						//jestlize je stisknuto nove tlac.
 {
  pin_old=(PIND&0b1110);
  //TLAC=true;
  mil_old=mil;
 }

}
else //zadne tlacitko neni stisknuto
 TLAC=true;
*/


if(!TLAC)if(TLAC!=tlac_old)	//jestlize bylo nastaveno TLAC==0 a na TLAC doslo ke zmene stavu (sestupna hrana)
 {
  mil_old=mil;

 }
tlac_old=TLAC;

#ifndef SIMULACE
if(tlac_on)if(mil-mil_old>400) //400
  {
	mil_old=mil;
	TLAC=true;
  }


}
#else
if(tlac_on)if(mil-mil_old>3) //400
  {
	mil_old=mil;
	TLAC=true;
  }
}
#endif

if(TIFR & (1<<OCF2))return; //jestlize nastalo preruseni T2



if(++opak==6)
{


opak=0;
if((PIND&0b1110)!=0b1110)x=0;	//jestlize je stisknuto nejake tlacitko

if(PODSVIT)
 {
  if(PODSVIT==2)
	{
	 if(++x<100)PODSVIT_ON;
	 else
	 {
	 PODSVIT_OFF;
	 x=100;
	 }
	}  
  else
  PODSVIT_ON;
 }
else PODSVIT_OFF;

}


}

//---------------------------------------------------
//Preruseni od ADC pri dokonceni prevodu
ISR(ADC_vect)
{
//mereni nastava kazdych 1,024ms
//mereni nastava kazdych 426,6666666us
int x=ADC;
char typ;
//static int data_nula[32];

static char nula_poz1=0;
static char nula_poz2=1;

static char poz=0;


typ=ADMUX&0b11;

if(reset_Vmer)
 {
  reset_Vmer=0;
  poz=0;
  data_prum_poz=0;
  VSTUP_Vmer;
  return;
 }

switch (typ)
{
case 3: //meri se napeti na baterce
		
		Vbat=((unsigned long int)x*1495)/1024; 

		if(!data_prum_poz)VSTUP_Vmer;	//jestlize jsou zpracovany namerene vzorky probehne dalsi mereni
		
		return;

case 0: //meri se napeti signalu
	
		data_prum[data_prum_poz]+=x;	//pod kazdy vzorek se ulozi 25 mereni
		
		if((++poz)==25)					//jestlize se 25x zmerilo a ulozilo napeti
		 {
	      //nastava po 25 vzorcich tj. po 10.666666ms
		  poz=0;
		  data_prum_poz++;

		  if(data_prum_poz==(MAX_DAT))
  	 	 	 {
  	  	  	  VSTUP_Vbat;	//az je prubeh zmeren nastavi se vstup Vbat,aby se neprepisoval prubeh a navic se zmeri akt. napeti baterky
			  return;
  	 	 	 }


	 	  data_prum[data_prum_poz]=0;
		 }


		return;

}

/*
if(typ==3)	//meri se napeti na baterce
 {
  //Vbat=((long int)x*1425)/1000;
    Vbat=((unsigned long int)x*2599)/1000;
 }

if(typ==2)	//meri se napeti nuly
{
 data_nula[nula_poz1]=x;
 nula+=data_nula[nula_poz1]-data_nula[nula_poz2];
 nula_poz1=(++nula_poz1)&0b11111;
 nula_poz2=(++nula_poz2)&0b11111; //nula_poz2=nula_poz1+1
 NULA=nula>>5;
 //NULA=nula;
}


if(typ==0) //meri se napeti signalu
{
//	data[data_poz++]=x;
	
	
	data_prum[data_prum_poz]+=x;
	if((++poz)==25)
	{
	
	poz=0;
	data_prum_poz++;
	data_prum[data_prum_poz]=0;
	}

	if(data_prum_poz>=(MAX_DAT))
  	 {
  	  VSTUP_Vnula;
  	 }

}
*/

}
//---------------------------------------------------
/*
volatile void delay_1m(int cas)
{
volatile int mil_old;
mil_old=mil;

while((mil-mil_old)<cas);

}
*/
//---------------------------------------------------
/*
void napeti_zmer(int *napeti,int *napeti_prum,int *i,int *h,int *hp)
{
static long nap_prum;
VSTUP_Vmer;
//AD_start;
if(!(*i)) nap_prum=0;
 
 if(data_prum_poz>=(MAX_DAT))
  {
   VSTUP_Vnula;
   data_prum_poz=0;
   *napeti=signal(&data_prum);
   nap_prum+=*napeti;
   *i++;
  }
*napeti_prum=nap_prum/ (*i);
*h=pow(10,(a*(*napeti+b)));  // y=10^(c*(x+d))
*hp=pow(10,(a*(*napeti_prum+b)));
}*/
//---------------------------------------------
unsigned int hloubka(int napeti)
{
//napeti=304;
//a=-0.06288;
//b=-64.4006;
return (log10(napeti)/a)-b;//y=(log(x)/c)-d
//return pow(10,(a*(napeti+b)));  // y=10^(c*(x+d))
}

//---------------------------------------------
int main( void )
{
//unsigned int sec_old,mil_old;
//int x;
unsigned char pom,pom2;
unsigned char ven;
int napeti;
unsigned long napeti_prum;
unsigned char menu_poz=MENU_POZ_DEFAULT;
unsigned char i_text;
unsigned int l=100;
unsigned char j,ax;
char i;

char pom_text[10];

unsigned int lx[2],ux[2];
unsigned int h;
unsigned char cit_old=10;
unsigned char blik,blik_LCD=0;

unsigned int mil_old=0;


signed int pocet_vzorku=POCET_VZORKU_DEF;


//goto sem;


// ******Nastaveni portu******
DDRB= 0b00110010;
PORTB=0b00110000;
DDRC= 0b00101111;
PORTC=0b00000000;
DDRD= 0b10000001;
PORTD=0b00011110; 

demx(5);

// ********Nastaveni ta a asova******** 
// *******ta asova1*******
/*
TCCR1B = 0x0A;
TCCR1A = 0x40;
TCNT1 = 0x00;
OCR1A = 4-1;	//93,75kHz (100*937,5Hz)
OCR1B = 0x00;
*/

TCCR1B = 0b00001001;
TCCR1A = 0b01000000;
TCNT1 = 0;
ICR1 = 0;
OCR1A = 31;
OCR1B = 0;

/*
sei();
demx(5);
while(1);*/


// *******ta asova2*******
// Input signal: CK/256 (f=23,438kHz, T=42,667us)
// Timer mode: CTC with OCR2
// Timer/Counter2 Compare Match OCR2
// Out. OC2 disconnected


/*
TCCR2 = 0b00001110;
ASSR = 0b00000000;
TIMSK = 0b10000000;
TCNT2 = 0;
OCR2 = 23;
*/

// *******ta asova2*******
// Vstupn signl: CK/64 (f=93,75kHz, T=10,667us)
// Md asovae: CTC, pi shod s OCR2
// Peruen pi shod s kom. reg. OCR2
// Vstup OC2 odpojen


TCCR2 = 0b00001100;
ASSR = 0b00000000;
TIMSK = 0b10000000;
TCNT2 = 0;
OCR2 = 39;



// *******ta asova0*******
// Vstupn signl: CK/256 (f=23,438kHz, T=42,667us)
// Peruen pi peteen T/T0
#ifndef SIMULACE
TCCR0 = 0b00000100;
TIMSK |= 0b00000001;
TCNT0 = 0;
#else
TCCR0 = 0b00000010;
TIMSK |= 0b00000001;
TCNT0 = 0;
#endif

//Nastaveni ADC
VSTUP_Vbat;
ADCSRA=0b11001000 + 5;	//Zapnuti AD a nastaveni predelicky 2^4 (32->6e6/32=187500->14.423kSa->69us)
// (1<<ADEN ) | (1<<ADSC) | (1<<ADIE) | ADPS

//MCUCR|=0b10010000;



sei();		// Zapnut vech peruen

load_EEPROM();
LCD_init();

//goto sem;
/*
//Kalibracni konstanty pro civku 1 a algoritmicke mereni
CIVKA=0;
CITLIVOST=6;
ALGORIT=1;

a=-0.023514472;
b=-169.96265;
save_kalib(CITLIVOST-1,CIVKA,ALGORIT);


CITLIVOST=5;


a=-0.012884922;
b=-313.88922;
save_kalib(CITLIVOST-1,CIVKA,ALGORIT);


CITLIVOST=4;


a=-0.0087947883;
b=-460.638;
save_kalib(CITLIVOST-1,CIVKA,ALGORIT);


CITLIVOST=3;


a=-0.0060081766;
b=-673.33093;
save_kalib(CITLIVOST-1,CIVKA,ALGORIT);


CITLIVOST=2;


a=-0.004094311;
b=-987.84259;
save_kalib(CITLIVOST-1,CIVKA,ALGORIT);


CITLIVOST=1;


a=-0.0029575473;
b=-1398.5427;
save_kalib(CITLIVOST-1,CIVKA,ALGORIT);

*/

pozice_LCD(0);
LCD_w_string_pgm(PSTR("Radiomajak 2.2.3"));
pozice_LCD2(0);
LCD_w_string_pgm(PSTR("   2007-2012"));

delay_1m(2000);
pozice_LCD2(0);
LCD_w_string_pgm(PSTR("   (c) Radek"));
delay_1m(2000);

/*
strcpy_P(&bezici_buf,PSTR("Navod a info k pouzivani na adrese: www.kopeme.zde.cz"));
i_text=0;
LCD_w_string_bezici(&bezici_buf,i_text++);
delay_1m(400);




while(LCD_w_string_bezici(&bezici_buf,i_text++))
{


pozice_LCD2(0);
if((i_text/4)<9)
LCD_w_string_pgm(video+17*(i_text/4));

delay_1m(200);
pozice_LCD(0);

}

delay_1m(1000);
*/
while(1)
 {


//meri se napeti nuly




volume(&CITLIVOST,6);

if(CITLIVOST>0)
 {
 demx(CITLIVOST-1);
 
 if(CITLIVOST!=cit_old)
  {
   read_kalib(CITLIVOST-1,CIVKA,ALGORIT);
   cit_old=CITLIVOST;
  } 
 
 }
else 
 {
  if(!(ax--))	//po ax ciklech se upravi CITLIVOST_AUTO
   { 
     ax=40;
     if(napeti>750)CITLIVOST_AUTO++;

     if(napeti<100)CITLIVOST_AUTO--;

     if(CITLIVOST_AUTO>=6)CITLIVOST_AUTO=6;
     if(CITLIVOST_AUTO<=1)CITLIVOST_AUTO=1;

     demx(CITLIVOST_AUTO-1);
   }

  if(CITLIVOST_AUTO!=cit_old)
   {
    read_kalib(CITLIVOST_AUTO-1,CIVKA,ALGORIT);
    cit_old=CITLIVOST_AUTO;
   }

 }
 

if(data_prum_poz>=(MAX_DAT))
{
//VSTUP_Vnula;
napeti=signal(&data_prum);
data_prum_poz=0;
}


if((napeti<MIN_NAP || napeti>MAX_NAP)&&!((blik++/2)%5))blik_LCD=true;
else blik_LCD=false;

//h=pow(10,(a*(napeti+b)));  // y=10^(c*(x+d))
h=hloubka(napeti);


pozice_LCD(0);
LCD_w_string_pgm(PSTR("h=000.0m M......"));

pozice_LCD(2);
if(blik_LCD)
LCD_w_string_pgm(PSTR("     "));
else
LCD_w_int2str(h,-5,1);


pozice_LCD(9);

if(CITLIVOST)
{
LCD_w_char('M');
pozice_LCD(9+CITLIVOST);
LCD_w_char('0'+CITLIVOST);
}
else
{
LCD_w_char('A');
LCD_w_char('0'+CITLIVOST_AUTO);
}





pozice_LCD2(0);
LCD_w_string_pgm(PSTR("U=       "));//w_string("U=000           ");


pozice_LCD2(2);
if(blik_LCD)
LCD_w_string_pgm(PSTR("    "));
else
LCD_w_int2str(napeti,-4,0);



if(Vbat<700)
{
pozice_LCD2(7);
LCD_w_string_pgm(PSTR("BAT"));
if(blik_LCD)LCD_w_char(' ');
else LCD_w_char('!');
LCD_w_char(' ');
LCD_w_int2str(Vbat/10,0,1);
LCD_w_char('V');

}
else
{

pozice_LCD2(9);
 LCD_w_char('C');
 LCD_w_char('v');
 LCD_w_char('1'+CIVKA);
 LCD_w_char(' ');

if(ALGORIT)
 LCD_w_string_pgm(PSTR("Alg"));
else
 LCD_w_string_pgm(PSTR("Pru"));

}


delay_1m(100);

//TLAC=false;
	
	if(TLAC1 && TLAC)	//jestlize je stisknuto prostredni tlac.
	{
	 delay_1m(100);
	 TLAC=false;
	 while(1)
	 {
	 

	 pozice_LCD(0);
	 LCD_w_string_pgm(PSTR("Menu:   ******* "));
	 pozice_LCD(8+menu_poz);
	 LCD_w_char('1'+menu_poz);

	 pozice_LCD2(0);
	 //LCD_w_string_pgm((&menu[0])+(menu_poz*9));
	 LCD_w_menu_pgm(&menu[0],9,menu_poz);
	 LCD_w_string_pgm(&nic[0]);  //"       "
	 //delay_1m(100);
	 volume(&menu_poz,6);

	 if(TLAC1 && TLAC)
	  {
	  	TLAC=false;
		
		switch (menu_poz)
		{
	
		case 0:	//Mereni
					
					do
					{
					pozice_LCD(0);
					//LCD_w_string_pgm(PSTR("Algoritmus:  ** "));//w_string("Algoritmus:  ** ");
					LCD_w_string_pgm(PSTR("Typ mereni:  ** "));

	 				pozice_LCD(13+ALGORIT);
	 				LCD_w_char('1'+ALGORIT);
					
					pozice_LCD2(0);

					volume(&ALGORIT,1);
					//LCD_w_string_pgm((&menu_algo[0])+(ALGORIT*11));
					LCD_w_menu_pgm(&menu_algo[0],11,ALGORIT);

 					
					delay_1m(100);
					}while(!(TLAC1 && TLAC));

					eeprom_write_byte (&EE_ALGORIT, ALGORIT);	
					cit_old=-1;				

					break;


		case 1: //Civka
					
					pom=CIVKA;
					do
					{
					volume(&CIVKA,CIVEK); //CIVEK=9
					pozice_LCD(0);
					//LCD_w_string_pgm(&menu_2[0]);//w_string("Vyber vys.civku: ");
					LCD_w_string_pgm(PSTR("Vyber vys.civku:"));
					
					pozice_LCD2(0);
					LCD_w_string("Civka:  (vyb: ) ");
					pozice_LCD2(13);
					LCD_w_char('1'+pom);								
					pozice_LCD2(6);
  					LCD_w_char('1'+CIVKA);
  					
					delay_1m(100);
					}while(!(TLAC1 && TLAC));

					eeprom_write_byte (&EE_CIVKA, CIVKA);	

					cit_old=-1;	

					break;




		case 2: //Kalib
					/*
					Kalibrace?
					Ano Ne
					-----------
					Nalezni napeti mezi 600-750 a zadej vzdalenost l od vysilace.Pak stiskni OK.
					U=0000 l=000.0m
					-----------
					Kalibruji....

					-----------
					Nalezni napeti mezi 170-220 a zadej vzdalenost l od vysilace.Pak stiskni OK.
					U=0000 l=000.0m
					-----------
					Kalibruji....

					-----------
					Napeti mezi 600-750 a zadej vzdalenost l. Pak OK
					U=0000 l=000.0m
					-----------
					Kalibruji....

					-----------
					Napeti mezi 170-220 a zadej vzdalenost l. Pak OK
					U=0000 l=000.0m
					-----------
					Kalibruji....

					-----------

					*/



					pom=0;
					do
					{
					pozice_LCD(0);
					LCD_w_string_pgm(PSTR("Kalibrovat?  ** "));
					
					volume(&pom,1);
	 				pozice_LCD(13+pom);
	 				LCD_w_char('1'+pom);
					
					pozice_LCD2(0);
					LCD_w_menu_pgm(&menu_ano_ne[0],7,pom);

 					
					//delay_1m(100);
					}while(!(TLAC1 && TLAC));

					TLAC=0;

					if(!pom)break;	//jestlize se nema kalibrovat
//----------------------

sem:				
					
					do
					{
					pozice_LCD(0);
					LCD_w_string_pgm(PSTR("Pocet vzorku    "));
					pozice_LCD2(0);
					LCD_w_string_pgm(PSTR("prumerovani: "));
					//	
					pocet_vzorku=volume2(pocet_vzorku,99);
					
					LCD_w_int2str(pocet_vzorku,-2,0);
					LCD_w_char(' ');

 					
					delay_1m(100);
					
					}while(!(TLAC1 && TLAC));

					
					TLAC=0;

//---------------------					



					for(i=0;i<6*2;i++)
					{//a
					/******/
					
					demx(i/2);

					

					strcpy_P(&bezici_buf,PSTR("Kalibrace citlivosti "));
					
					pom_text[0]=i/2+'1';
					pom_text[1]=i%2+'a';
					pom_text[2]=0;
					
					strcat(&bezici_buf,&pom_text);
					strcat_P(&bezici_buf,PSTR(": Nalezni napeti mezi "));
					
					if(i%2)
					 strcat_P(&bezici_buf,PSTR("170-220"));
					else
					 strcat_P(&bezici_buf,PSTR("600-750"));

					strcat_P(&bezici_buf,PSTR(" a zadej vzdalenost l od vysilace.Pak stiskni OK."));
					/********/
					
					pom=10;
					pom2=0;
					
					i_text=0;
					LCD_w_string_bezici(&bezici_buf,i_text++);

					do
					{//b

					
					if((i_text==1) || (0==i_text))if(pom--)goto cekej;	//cekani pri zobrazeni noveho textu


					pom=10;
					if((++pom2)%2)
					if(!LCD_w_string_bezici(&bezici_buf,i_text++))
					 {
						
						i_text=0;


					 }

cekej:
										

				
					//VSTUP_Vmer;
					
					//AD_start;
					
					if(data_prum_poz>=(MAX_DAT))
					{
					//VSTUP_Vnula;
					napeti=signal(&data_prum);
					data_prum_poz=0;
					}
					//napeti_zmer(&napeti,&x,0,&x,&x);
					
					pozice_LCD2(0);
					LCD_w_char(pom_text[0]);	//citlivost 1-6
					LCD_w_char(pom_text[1]);	//kalibrace a nebo b
										
			
					LCD_w_string_pgm(PSTR(" U=    l="));
					
					pozice_LCD2(5);
					LCD_w_int2str(napeti,-3,0);
					l=volume2(l,9999);
					pozice_LCD2(11);
					LCD_w_int2str(l,-4,1);
					LCD_w_char('m');
					LCD_w_char(' ');


					delay_1m(100);
					
                    }while(!(TLAC1 && TLAC));//b  	//smycka se opusti pokud je stisknuto OK
					TLAC=0;


					//Provede se prumerovani...
					
					napeti=0;
					napeti_prum=0;
					cli();
					reset_Vmer=true;	//zapnuti ADC prevodu mereni signalu
					data_prum_poz=0;
					sei();

					for(j=0;j<=pocet_vzorku;)
					{
					//VSTUP_Vmer;
					//demx((i)/2);
					//AD_start;
					
					if(data_prum_poz>=(MAX_DAT))
					{
					//VSTUP_Vnula;
					napeti=signal(&data_prum);
					data_prum_poz=0;
					//int2str(napeti);
					if(j)napeti_prum+=napeti;
					j++;
					}

					//napeti_zmer(&napeti,&napeti_prum,&j,&x,&h);

					pozice_LCD(0);
					LCD_w_string_pgm(PSTR("Cekej "));
					LCD_w_int2str(pocet_vzorku-j,-2,0);
					LCD_w_string_pgm(PSTR("  U="));
					LCD_w_int2str(napeti,-3,0);
					LCD_w_string_pgm(PSTR("   "));
					pozice_LCD2(0);
					LCD_w_string_pgm(PSTR("Cancel       ^ v"));
					//LCD_w_string_pgm(PSTR("Cancel stisk:^ v"));
					
					if(((TLAC0 || TLAC2)&& TLAC)){TLAC=0;break;}	//jestlize je stisknuto V nebo ^
					}
					napeti_prum/=(j-1);


					lx[i%2]=l;
					ux[i%2]=napeti_prum;
					
					if(i%2)
					 {//d
           			  a=(log10(ux[1])-log10(ux[0]))/(lx[1]-lx[0]);//c=(log(y2)-log(y1))/(x2-x1)
					  b=(log10(ux[1])/a)-lx[1];	//d=(log(y1)/c)-x1
	
					 
					  pom=0;
					  do
					  {//c


					  if(data_prum_poz>=(MAX_DAT))
					  {
					   //VSTUP_Vnula;
					   napeti=signal(&data_prum);
					   data_prum_poz=0;
					  }
			
					  h=hloubka(napeti);

				
					  

					  volume(&pom,2);
					  
					  pozice_LCD(0);
					  if(pom==2)
					  LCD_w_string_pgm(PSTR("Neukladat.   **3"));
					  else
					  {
					  LCD_w_string_pgm(PSTR("Zk.dobre?"));
					  
					  //LCD_w_string_pgm((&menu_ano_ne[0])+(pom*7));
					  
					  LCD_w_menu_pgm(&menu_ano_ne[0],7,pom);

					  pozice_LCD(13);
					  if(pom)
					  {
					   LCD_w_string_pgm(PSTR("*2*"));
					  }
					  else
					  {
					   LCD_w_string_pgm(PSTR("1**"));
					  }
					  }
					  
			


					  pozice_LCD2(0);
					  LCD_w_char('C');
					  LCD_w_char(pom_text[0]);
					  LCD_w_string(" U=000 h=");
					
					  pozice_LCD2(5);
					  LCD_w_int2str(napeti,-3,0);
					
					  
					  pozice_LCD2(11);
					  LCD_w_int2str(h,-4,1);
					  LCD_w_char('m');
					  LCD_w_char(' ');

							
	
 					
					  delay_1m(20);
					  
					  
					  
					  }while(!(TLAC1 && TLAC));//c
					  TLAC=0;

					  if(!pom)i-=2;	//jestlize kalibrace neni dobra kalibruje se znova
					  
					  if(pom==1)save_kalib(i/2,CIVKA,ALGORIT); //jestlize je kalibrace dobra ulozi se konstanty a kalib. se dalsi citlivost

					 }//d





					}//a

					pozice_LCD(0);
					LCD_w_string_pgm(PSTR("Kalibrace hotova"));
					pozice_LCD2(0);
					LCD_w_string_pgm(&nic);
					delay_1m(1000);
					cit_old=-1;	//aby se nacetli koeficienty "a" a "b" pro novou citlivost 

					break;
	

		case 3: //Ubat
				  	
					
		
					do
					{
					//VSTUP_Vbat;
					unsigned int x;
					
					if(!((pom++)%8))
					{
					pozice_LCD(0);
					LCD_w_string_pgm(PSTR("Napeti baterii:  "));
					pozice_LCD2(0);
  					
					cli();
					x=Vbat;
					sei();
					LCD_w_int2str(x,0,2);

  					LCD_w_char('V');
  					LCD_w_char(' ');
					}


					delay_1m(20);
					}while(!(TLAC1 && TLAC));



					break;

		case 4: //Podsvit
					
					do
					{
					
					pozice_LCD(0);
					LCD_w_string_pgm(PSTR("Podsvetleni: ***"));
					
					pozice_LCD(13+PODSVIT);
	 				LCD_w_char('1'+PODSVIT);
	

    				volume(&PODSVIT,2);

					pozice_LCD2(0);
					//LCD_w_string_pgm((&menu_podsvit[0])+(PODSVIT*8));
					LCD_w_menu_pgm(&menu_podsvit[0],8,PODSVIT);

 					
					delay_1m(20);
					}while(!(TLAC1 && TLAC));

					eeprom_write_byte (&EE_PODSVIT, PODSVIT);						
					
					break;

		case 5: //Prumeruj
					i=0;
					napeti_prum=0;
					cli();
					reset_Vmer=true;
					data_prum_poz=0;
					sei();

					do
					{

					  
					  //VSTUP_Vmer;
					  //AD_start;
					  if(data_prum_poz>=(MAX_DAT))
					  {
					   //VSTUP_Vnula;
					   napeti=signal(&data_prum);
					   data_prum_poz=0;
					   napeti_prum+=napeti;
					   i++;
					  }
					  
					 // napeti_zmer(&napeti,&napeti_prum,&i,&x,&h);


					pozice_LCD(0);

					LCD_w_char(248); //znak prumer
					LCD_w_char(' ');
					LCD_w_char('C');
					LCD_w_char('0'+CITLIVOST);
					LCD_w_char(' ');
					LCD_w_char(246);	//znak suma
					LCD_w_int2str(i,-2,0);
					LCD_w_string_pgm(PSTR(" U="));
					LCD_w_int2str(napeti,-3,0);
					LCD_w_char(' ');
					

				    //h=pow(10,(a*(napeti_prum/i+b)));
					h=hloubka(napeti_prum/i);

					pozice_LCD2(0);
					//LCD_w_string_pgm(PSTR("Up=    hp=     m"));
					LCD_w_string_pgm(PSTR("Up="));
					LCD_w_int2str(napeti_prum/i,-3,0);
					LCD_w_string_pgm(PSTR(" hp="));
					LCD_w_int2str(h,-4,1);
					LCD_w_char('m');
					LCD_w_char(' ');

 					
					delay_1m(20);
					}while(!(TLAC1 && TLAC));
					break;

		case 6: //Cancel
				menu_poz=MENU_POZ_DEFAULT;
				delay_1m(200);
				ven=true;
		}
      TLAC=false;
	  if(ven){ven=false;break;}


	  }
	 }

	}

		
 }
return (1);
}
